macro case a, b {
  local d
  cmp eax, a
  jnz d
  mov eax, b
  ret
  label d
}

; ------------------------------------------------------------
ide_select_head:
   case 0, 10100000b
   case 1, 10101000b
   case 2, 10100100b
   case 3, 10101100b
   case 4, 10100010b
   case 5, 10101010b
   case 6, 10100110b
   case 7, 10101110b
   case 8, 10100001b
   case 9, 10101001b
   case 10, 10100101b
   case 11, 10101101b
   case 12, 10100011b
   case 13, 10101011b
   case 14, 10100111b
   case 15, 10101111b
.exit:   ret

ata_rw:
      	xchg	eax, [esi]
	mov     dx,1f6h         ;Drive and head port
	call	ide_select_head
	out     dx,al
      	drop
	push eax
	push esi
	mov     dx,1f2h         ;Sector count port
	mov     al,1            ;Read one sector
	out     dx,al
	pop esi
	pop eax
	mov     dx,1f3h         ;Sector number port
	out     dx,al
	drop
	mov     dx,1f4h         ;Cylinder low port
	out     dx,al
	mov     dx,1f5h         ;Cylinder high port
	out     dx,al
      	drop
next


; ( CYLINDER HEAD SECTOR -- )
code 'read.sector', ide_read
	call ata_rw
	push eax
	mov     dx,1f7h         ;Command port
	mov     al,20h          ;Read with retry.
	out     dx,al
.a:	in      al,dx
	test    al,8            ;This means the sector buffer requires
				;servicing.
	jz      .a    		;Don't continue until the sector buffer
				;is ready.
	push edi
	mov     ecx,512/2        ;One sector /2
	mov     edi,ide_buffer
	mov     edx,1f0h         ;Data port - data comes in and out of here.
	rep     insw
	pop edi
	pop eax
next


; ( CYLINDER HEAD SECTOR -- )
code 'write.sector', ide_write
	call ata_rw
	push eax
	mov     dx,1f7h         ;Command port
	mov     al,30h          ;Read with retry.
	out     dx,al
.a:	in      al,dx
	test    al,8
	jz      .a     		;Don't continue until the sector buffer
				;is ready.
	push esi
	mov   	ecx,512/2       ;One sector /2
	mov     esi,ide_buffer
	mov     edx,1f0h         ;Data port - data comes in and out of here.
	rep     outsw
	pop esi
	pop eax
next

code 'sector', whereis_sector
	upsh ide_buffer
next

ide_buffer: times 512 db 0
