macro idt_entry {
dw 0
dw 0x8
dw 0x8E00
dw 0x20

dw 0
dw 0x8
dw 0x8E00
dw 0x20

dw 0
dw 0x8
dw 0x8E00
dw 0x20

dw 0
dw 0x8
dw 0x8E00
dw 0x20
}

macro hook_int a {
	 push default_int
	 push a
	 call hook
	 add esp, 8
}

default_int: iret

code 'hook', patch_int
     xchg eax, [esi]
     upop ecx
     push ecx
     upop ecx
     push ecx
     call hook
     add esp, 8
next

hook:			        ; hook(interrupt, *handler)
	push	ebx
	mov	eax, [esp+8]	        ; interrupt
	mov	ebx, [esp+12]	        ; handler
	shl	eax, 3		        ; EAX *= 8
	add	eax, [idt_pointer+2]
	mov     [eax], bx	        ; Low-order word of offset
	shr	ebx, 16
	mov     [eax+6], bx	        ; High-order word
	pop	ebx
	ret

init_idt:
	hook_int 0
	hook_int 6
	hook_int 1
	hook_int 2
	hook_int 3
	hook_int 4
	hook_int 5
	hook_int 6
	hook_int 7
	hook_int 8
	hook_int 9
	hook_int 10
	hook_int 11
	hook_int 12
	hook_int 13
	ret

start_of_idt:
 idt_entry      ; 4
 idt_entry      ; 8
 idt_entry      ; 12
 idt_entry      ; 16
 idt_entry      ; 20
 idt_entry      ; 24
 idt_entry      ; 4
 idt_entry      ; 8
 idt_entry      ; 12
 idt_entry      ; 16
 idt_entry      ; 20
 idt_entry      ; 24
end_of_idt:

idt_pointer:
 dw end_of_idt - start_of_idt - 1
 dd start_of_idt
